import { world, system, BlockPermutation } from '@minecraft/server'

world.beforeEvents.worldInitialize.subscribe(eventEvent => {
       eventEvent.blockComponentRegistry.registerCustomComponent('true:collection', {
       onPlayerInteract: eventData => {
              const block = eventData.block
              const player = eventData.player
              const blockLocation = block.location;
              const blockPos = block.location;
      if (block.permutation.getState('true:stage') == 4 && block.typeId == "true:bluk_berry_block") {
              block.setPermutation(block.permutation.withState('true:stage', block.permutation.getState('true:stage') - 4))
      system.run(() => {
              block.dimension.runCommandAsync(`loot spawn ${blockLocation.x} ${blockLocation.y - 1.0} ${blockLocation.z} loot "blocks/berries/bluk/harvest"`);
               }
             )
           }
      if (block.permutation.getState('true:stage') == 4 && block.typeId == "true:custap_berry_block") {
              block.setPermutation(block.permutation.withState('true:stage', block.permutation.getState('true:stage') - 4))
      system.run(() => {
              block.dimension.runCommandAsync(`loot spawn ${blockLocation.x} ${blockLocation.y - 1.0} ${blockLocation.z} loot "blocks/berries/custap/harvest"`);
               }
             )
           }
      if (block.permutation.getState('true:stage') == 4 && block.typeId == "true:aspear_berry_block") {
             block.setPermutation(block.permutation.withState('true:stage', block.permutation.getState('true:stage') - 4))
      system.run(() => {
             block.dimension.runCommandAsync(`loot spawn ${blockLocation.x} ${blockLocation.y - 1.0} ${blockLocation.z} loot "blocks/berries/aspear/harvest"`);
              }
            )
          }
      if (block.permutation.getState('true:stage') == 4 && block.typeId == "true:liechi_berry_block") {
            block.setPermutation(block.permutation.withState('true:stage', block.permutation.getState('true:stage') - 4))
      system.run(() => {
            block.dimension.runCommandAsync(`loot spawn ${blockLocation.x} ${blockLocation.y - 1.0} ${blockLocation.z} loot "blocks/berries/liechi/harvest"`);
             }
           )
         }
      if (block.permutation.getState('true:stage') == 4 && block.typeId == "true:oran_berry_block") {
            block.setPermutation(block.permutation.withState('true:stage', block.permutation.getState('true:stage') - 4))
      system.run(() => {
            block.dimension.runCommandAsync(`loot spawn ${blockLocation.x} ${blockLocation.y - 1.0} ${blockLocation.z} loot "blocks/berries/oran/harvest"`);
             }
           )
         }
     if (block.permutation.getState('true:stage') == 4 && block.typeId == "true:pomeg_berry_block") {
           block.setPermutation(block.permutation.withState('true:stage', block.permutation.getState('true:stage') - 4))
     system.run(() => {
           block.dimension.runCommandAsync(`loot spawn ${blockLocation.x} ${blockLocation.y - 1.0} ${blockLocation.z} loot "blocks/berries/pomeg/harvest"`);
             }
           )
         }
     if (block.permutation.getState('true:stage') == 4 && block.typeId == "true:yache_berry_block") {
          block.setPermutation(block.permutation.withState('true:stage', block.permutation.getState('true:stage') - 4))
     system.run(() => {
          block.dimension.runCommandAsync(`loot spawn ${blockLocation.x} ${blockLocation.y - 1.0} ${blockLocation.z} loot "blocks/berries/yache/harvest"`);
            }
          )
        }
       }
     }
   )
 }
)
world.beforeEvents.worldInitialize.subscribe(eventData => {
       eventData.blockComponentRegistry.registerCustomComponent('true:growth', {
       onTick: eventData => {
          const block = eventData.block
          const age = block.permutation.getState('true:stage')
         if (age < 4) {
          block.setPermutation(block.permutation.withState('true:stage', age + 1))
          }
        }
      }
    )
  }  
)
world.beforeEvents.worldInitialize.subscribe(eventData => {
     eventData.blockComponentRegistry.registerCustomComponent('true:cooking_smoke', {
     onTick: eventData => {
        const block = eventData.block
        const blockLocation = block.location;
        block.dimension.runCommandAsync(`particle minecraft:campfire_smoke_particle ${blockLocation.x} ${blockLocation.y + 0.5} ${blockLocation.z}`);
        }
      }
    )
  }  
)